package com.company.losttransient.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.JmixEntity;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.UUID;

@JmixEntity
@Table(name = "ENTITY_B_MAPPING", indexes = {
        @Index(name = "IDX_ENTITY_B_MAPPING_ENTITY_A", columnList = "ENTITY_A_ID"),
        @Index(name = "IDX_ENTITY_B_MAPPING_ENTITY_B", columnList = "ENTITY_B_ID")
})
@Entity
public class EntityBMapping {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @NotNull
    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "ENTITY_A_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private EntityA entityA;

    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "ENTITY_B_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private EntityB entityB;

    public EntityB getEntityB() {
        return entityB;
    }

    public void setEntityB(EntityB entityB) {
        this.entityB = entityB;
    }

    public EntityA getEntityA() {
        return entityA;
    }

    public void setEntityA(EntityA entityA) {
        this.entityA = entityA;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}