package com.company.losttransient.screen.entitya;

import com.company.losttransient.entity.EntityB;
import com.company.losttransient.entity.EntityBMapping;
import com.company.losttransient.screen.entityb.EntityBEdit;
import io.jmix.core.DataManager;
import io.jmix.ui.Notifications;
import io.jmix.ui.ScreenBuilders;
import io.jmix.ui.action.Action;
import io.jmix.ui.model.CollectionPropertyContainer;
import io.jmix.ui.model.InstanceContainer;
import io.jmix.ui.screen.*;
import com.company.losttransient.entity.EntityA;
import org.springframework.beans.factory.annotation.Autowired;


@UiController("EntityA.edit")
@UiDescriptor("entity-a-edit.xml")
@EditedEntityContainer("entityADc")
public class EntityAEdit extends StandardEditor<EntityA> {
    @Autowired
    private InstanceContainer<EntityA> entityADc;
    @Autowired
    private CollectionPropertyContainer<EntityBMapping> entityBMappingDc;
    @Autowired
    private DataManager dataManager;
    @Autowired
    private ScreenBuilders screenBuilders;
    @Autowired
    private Notifications notifications;

    @Subscribe("entityBMappingsTable.add")
    public void onEntityBMappingsTableAdd(Action.ActionPerformedEvent event) {
        screenBuilders.lookup(EntityB.class, this)
                .withOpenMode(OpenMode.DIALOG)
                .withSelectHandler(entityB ->
                        entityB.stream()
                                .map(this::createEntityB)
                                .forEach(this::addEntityB)
                )
                .build()
                .show();
    }

    private EntityBMapping createEntityB(EntityB entityB) {

        EntityBMapping EntityBMapping = dataManager.create(EntityBMapping.class);
        EntityBMapping.setEntityA(entityADc.getItem());
        EntityBMapping.setEntityB(entityB);

        if (entityB.getCreateEntityCInstance()) {
            notifications.create(Notifications.NotificationType.HUMANIZED).withCaption("Create Entity C Instance - SELECTED").show();
        } else {
            notifications.create(Notifications.NotificationType.HUMANIZED).withCaption("Create Entity C Instance - NOT SELECTED").show();
        }

        return EntityBMapping;
    }

    private void addEntityB(EntityBMapping entityBMapping) {
        entityBMappingDc.getMutableItems().add(entityBMapping);
    }

    @Subscribe("entityBMappingsTable.edit")
    public void onEntityBMappingsTableEdit(Action.ActionPerformedEvent event) {

        screenBuilders.editor(EntityB.class, this)
                .withOpenMode(OpenMode.DIALOG)
                .editEntity(entityBMappingDc.getItem().getEntityB())
                .withScreenClass(EntityBEdit.class)
                .withAfterCloseListener(afterCloseEvent -> {
                    CloseAction closeAction = afterCloseEvent.getCloseAction();
                    if (!((StandardCloseAction) closeAction).getActionId().equals("mainMenu")) {
                        entityBMappingDc.getItem().setEntityB(afterCloseEvent.getSource().getEditedEntity());
                    }
                })
                .build()
                .show();
    }
}