package com.company.losttransient.screen.entityb;

import io.jmix.ui.ScreenBuilders;
import io.jmix.ui.action.Action;
import io.jmix.ui.component.GroupTable;
import io.jmix.ui.model.DataContext;
import io.jmix.ui.screen.*;
import com.company.losttransient.entity.EntityB;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.ArrayList;

@UiController("EntityB.browse")
@UiDescriptor("entity-b-browse.xml")
@LookupComponent("entityBsTable")
public class EntityBBrowse extends StandardLookup<EntityB> {
    @Autowired
    private DataContext dataContext;
    @Autowired
    private ScreenBuilders screenBuilders;
    @Autowired
    private GroupTable<EntityB> entityBsTable;

    @Subscribe("entityBsTable.create")
    public void onEntityBsTableCreate(Action.ActionPerformedEvent event) {

        EntityB entityB = dataContext.create(EntityB.class);

        screenBuilders.editor(entityBsTable)
                .newEntity(entityB)
                .withOpenMode(OpenMode.DIALOG)
                .withScreenClass(EntityBEdit.class)
                .withAfterCloseListener(afterScreenCloseEvent -> {
                    if (afterScreenCloseEvent.closedWith(StandardOutcome.COMMIT)) {
                        EntityB newEntityB = afterScreenCloseEvent.getSource().getEditedEntity();
                        entityBsTable.setSelected(newEntityB);
                    }
                })
                .build()
                .show();

    }
}