package com.company.losttransient.screen.entityb;

import io.jmix.core.EntityStates;
import io.jmix.ui.action.Action;
import io.jmix.ui.component.CheckBox;
import io.jmix.ui.model.InstanceContainer;
import io.jmix.ui.screen.*;
import com.company.losttransient.entity.EntityB;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.lang.NonNull;

@UiController("EntityB.edit")
@UiDescriptor("entity-b-edit.xml")
@EditedEntityContainer("entityBDc")
public class EntityBEdit extends StandardEditor<EntityB> {
    @Autowired
    private InstanceContainer<EntityB> entityBDc;
    @Autowired
    private EntityStates entityStates;
    @Autowired
    private CheckBox createEntityCInstanceField;

    @Subscribe
    public void onAfterShow(AfterShowEvent event) {
        createEntityCInstanceField.setVisible(entityStates.isNew(entityBDc.getItem()));
    }

    @Override
    protected void commitAndClose(@NonNull Action.ActionPerformedEvent event) {

        entityBDc.getItem().setCreateEntityCInstance(createEntityCInstanceField.getValue());

        super.commitAndClose(event);
    }
}